﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Telerik.WinControls.UI;
using Telerik.WinControls;

namespace RadGridViewBoxes
{
    public class CustomDropDownEditor : BaseGridEditor
    {
        CustomDropDownEditorElement customEditorElement;

        public override object Value
        {
            get
            {
                customEditorElement = (CustomDropDownEditorElement)this.EditorElement;

                if (customEditorElement.FirstDropDown.SelectedValue != null
                    && customEditorElement.SecondDropDown.SelectedValue != null
                    && customEditorElement.ThirdDropDown.SelectedValue != null)
                {
                    string result = customEditorElement.FirstDropDown.SelectedValue.ToString() + ";" +
                        customEditorElement.SecondDropDown.SelectedValue.ToString() + ";" +
                        customEditorElement.ThirdDropDown.SelectedValue.ToString();

                    return result;
                }
                else
                {
                    return string.Empty;
                }
            }
            set
            {
                customEditorElement = (CustomDropDownEditorElement)this.EditorElement;

                if (value != null && value != DBNull.Value)
                {
                    string [] str = value.ToString().Split(';');
                    customEditorElement.FirstDropDown.SelectedValue = str[0];
                    customEditorElement.SecondDropDown.SelectedValue = str[1];
                    customEditorElement.ThirdDropDown.SelectedValue = str[2];
                }
            }
        }
        public override void BeginEdit()
        {
            base.BeginEdit();
            this.EditorElement.Focus();

            customEditorElement = (CustomDropDownEditorElement)this.EditorElement;
            customEditorElement.FirstDropDown.TextBox.KeyDown += new System.Windows.Forms.KeyEventHandler(TextBox_KeyDown);
            customEditorElement.SecondDropDown.TextBox.KeyDown += new System.Windows.Forms.KeyEventHandler(TextBox_KeyDown);
            customEditorElement.ThirdDropDown.TextBox.KeyDown += new System.Windows.Forms.KeyEventHandler(TextBox_KeyDown);
        }

        void TextBox_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e)
        {
            if (e.KeyValue == 13)
            {
                ((GridDataCellElement)this.OwnerElement).GridControl.EndEdit();
            }
        }

        public override bool EndEdit()
        {
            customEditorElement = (CustomDropDownEditorElement)this.EditorElement;
            customEditorElement.FirstDropDown.TextBox.KeyDown += new System.Windows.Forms.KeyEventHandler(TextBox_KeyDown);
            customEditorElement.SecondDropDown.TextBox.KeyDown += new System.Windows.Forms.KeyEventHandler(TextBox_KeyDown);
            customEditorElement.ThirdDropDown.TextBox.KeyDown += new System.Windows.Forms.KeyEventHandler(TextBox_KeyDown);
            return base.EndEdit();
        }

        protected override RadElement CreateEditorElement()
        {
            return new CustomDropDownEditorElement();
        }
    }
}
