﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace RadGridViewBoxes
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.radGridView1.AutoSizeColumnsMode = GridViewAutoSizeColumnsMode.Fill;

            GridViewTextBoxColumn col = new GridViewTextBoxColumn();
            col.Name = "ID";
            col.HeaderText = "ID";
            this.radGridView1.Columns.Add(col);

            col = new GridViewTextBoxColumn();
            col.Name = "Name";
            col.HeaderText = "Name";
            col.Width = 150;
            this.radGridView1.Columns.Add(col);

            this.radGridView1.BeginUpdate();

            for (int i = 0; i < 100; i++)
            {
                GridViewDataRowInfo row = new GridViewDataRowInfo(this.radGridView1.MasterView);
                row.Cells[0].Value = i;
                row.Cells[1].Value = "Name " + i.ToString();
                this.radGridView1.Rows.Add(row);
            }

            this.radGridView1.Rows[2].Cells[1].Value = "1;3;8";

            this.radGridView1.EndUpdate();

            this.radGridView1.EditorRequired += new EditorRequiredEventHandler(radGridView1_EditorRequired);
            this.radGridView1.CellEditorInitialized += new GridViewCellEventHandler(radGridView1_CellEditorInitialized);

            DataColumn dc = new DataColumn();
            dc.ColumnName = "FirstValue";
            dtForFirstCombo.Columns.Add(dc);

            dc = new DataColumn();
            dc.ColumnName = "FirstDesc";
            dtForFirstCombo.Columns.Add(dc);

            for (int i = 0; i < 100; i++)
            {
                DataRow dr = dtForFirstCombo.NewRow();
                dr[0] = i;
                dr[1] = "Desc " + i.ToString();
                dtForFirstCombo.Rows.Add(dr);
            }

            dc = new DataColumn();
            dc.ColumnName = "SecondValue";
            dtForSecondCombo.Columns.Add(dc);

            dc = new DataColumn();
            dc.ColumnName = "SecondDesc";
            dtForSecondCombo.Columns.Add(dc);

            for (int i = 0; i < 100; i++)
            {
                DataRow dr = dtForSecondCombo.NewRow();
                dr[0] = i;
                dr[1] = "Desc " + i.ToString();
                dtForSecondCombo.Rows.Add(dr);
            }           

            dc = new DataColumn();
            dc.ColumnName = "ThirdValue";
            dtForThirdCombo.Columns.Add(dc);

            dc = new DataColumn();
            dc.ColumnName = "ThirdDesc";
            dtForThirdCombo.Columns.Add(dc);

            for (int i = 0; i < 100; i++)
            {
                DataRow dr = dtForThirdCombo.NewRow();
                dr[0] = i;
                dr[1] = "Desc " + i.ToString();
                dtForThirdCombo.Rows.Add(dr);
            }
        }

        DataTable dtForFirstCombo = new DataTable();
        DataTable dtForSecondCombo = new DataTable();
        DataTable dtForThirdCombo = new DataTable();

        void radGridView1_CellEditorInitialized(object sender, GridViewCellEventArgs e)
        {
        }

        void radGridView1_EditorRequired(object sender, EditorRequiredEventArgs e)
        {
            if (this.radGridView1.CurrentColumn.Name == "Name"
                && this.radGridView1.Rows.IndexOf(this.radGridView1.CurrentRow) == 2)
            {
                CustomDropDownEditor editor = new CustomDropDownEditor();
                CustomDropDownEditorElement customEditor = (CustomDropDownEditorElement)editor.EditorElement;

                customEditor.FirstDropDown.DataSource = dtForFirstCombo;
                customEditor.FirstDropDown.DisplayMember = "FirstDesc";
                customEditor.FirstDropDown.ValueMember = "FirstValue";

                customEditor.SecondDropDown.DataSource = dtForSecondCombo;
                customEditor.SecondDropDown.DisplayMember = "SecondDesc";
                customEditor.SecondDropDown.ValueMember = "SecondValue";

                customEditor.ThirdDropDown.DataSource = dtForThirdCombo;
                customEditor.ThirdDropDown.DisplayMember = "ThirdDesc";
                customEditor.ThirdDropDown.ValueMember = "ThirdValue";

                e.Editor = editor;
            }
        }
    }
}
